"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var components_1 = require("../components");
require("./styles.css");
var Rating = function (_a) {
    var _b = _a.precision, precision = _b === void 0 ? 1 : _b, _c = _a.count, count = _c === void 0 ? 5 : _c, _d = _a.shape, shape = _d === void 0 ? 'star' : _d, _e = _a.defaultValue, defaultValue = _e === void 0 ? 0 : _e, onChange = _a.onChange, onHover = _a.onHover, _f = _a.classNames, classNames = _f === void 0 ? '' : _f, _g = _a.readOnly, readOnly = _g === void 0 ? false : _g, _h = _a.size, size = _h === void 0 ? '24px' : _h, _j = _a.spacing, spacing = _j === void 0 ? '5px' : _j, _k = _a.activeColor, activeColor = _k === void 0 ? 'orange' : _k, _l = _a.defaultColor, defaultColor = _l === void 0 ? 'gray' : _l, _m = _a.titleArray, titleArray = _m === void 0 ? ['Poor', 'Good', 'Very Good', 'Best', 'Excellent'] : _m, _o = _a.showTitle, showTitle = _o === void 0 ? false : _o;
    if (showTitle && titleArray.length < count) {
        throw new Error('titleArray length must be greater than or equal to count.');
    }
    var _p = (0, react_1.useState)(defaultValue), activeIcon = _p[0], setActiveIcon = _p[1];
    var _q = (0, react_1.useState)(-1), hoverActiveIcon = _q[0], setHoverActiveIcon = _q[1];
    var _r = (0, react_1.useState)(false), isHovered = _r[0], setIsHovered = _r[1];
    var ratingContainerRef = (0, react_1.useRef)(null);
    var calculateRating = function (e) {
        var _a;
        var _b = ratingContainerRef.current.getBoundingClientRect(), width = _b.width, left = _b.left;
        var percent = (e.clientX - left) / width;
        var numberInStars = percent * count;
        var nearestNumber = Math.round((numberInStars + precision / 2) / precision) * precision;
        return Number(nearestNumber.toFixed(((_a = precision.toString().split('.')[1]) === null || _a === void 0 ? void 0 : _a.length) || 0));
    };
    var handleClick = function (e) {
        if (readOnly)
            return;
        setIsHovered(false);
        setActiveIcon(calculateRating(e));
        onChange && onChange(calculateRating(e));
    };
    var handleMouseMove = function (e) {
        if (readOnly)
            return;
        setIsHovered(true);
        setHoverActiveIcon(calculateRating(e));
        onHover && onHover(calculateRating(e));
    };
    var handleMouseLeave = function () {
        if (readOnly)
            return;
        setHoverActiveIcon(-1); // Reset to default state
        setIsHovered(false);
    };
    var ICON_STYLES = {
        width: size,
        height: size,
    };
    var IconProps = {
        ICON_STYLES: ICON_STYLES,
        COLOR: activeColor,
        DEFAULT_COLOR: defaultColor,
    };
    var getShape = function (style) {
        switch (shape) {
            case 'heart':
                if (style === 'full')
                    return react_1.default.createElement(components_1.HeartFullIcon, tslib_1.__assign({}, IconProps));
                return react_1.default.createElement(components_1.HeartEmptyIcon, tslib_1.__assign({}, IconProps));
            default:
                if (style === 'full')
                    return react_1.default.createElement(components_1.FullStar, tslib_1.__assign({}, IconProps));
                return react_1.default.createElement(components_1.EmptyStar, tslib_1.__assign({}, IconProps));
        }
    };
    return (react_1.default.createElement("div", { onClick: handleClick, onMouseMove: handleMouseMove, onMouseLeave: handleMouseLeave, ref: ratingContainerRef, className: "md-rating-container ".concat(classNames, " ").concat(readOnly ? 'md-rating-container--readonly' : ''), style: {
            gap: spacing,
        } }, new Array(count).fill('').map(function (_, index) {
        var activeState = isHovered ? hoverActiveIcon : activeIcon;
        var showEmptyIcon = activeState === -1 || activeState < index + 1;
        var isActiveRating = activeState !== 1;
        var isRatingWithPrecision = activeState % 1 !== 0;
        var isRatingEqualToIndex = Math.ceil(activeState) === index + 1;
        var showRatingWithPrecision = isActiveRating && isRatingWithPrecision && isRatingEqualToIndex;
        return (react_1.default.createElement("div", { className: 'md-rating-star', key: index },
            react_1.default.createElement("div", { className: 'md-rating-star--full', style: {
                    width: showRatingWithPrecision ? "".concat((activeState % 1) * 100, "%") : '0%',
                }, title: showTitle ? titleArray[index] : '' }, getShape('full')),
            react_1.default.createElement("div", null, showEmptyIcon ? getShape('empty') : getShape('full'))));
    })));
};
exports.default = Rating;
//# sourceMappingURL=index.js.map